import { IgxCancelEventArgs } from "igniteui-angular-core";
import { SpreadsheetEditRangePasswordNeededEventArgs as SpreadsheetEditRangePasswordNeededEventArgs_internal } from "./SpreadsheetEditRangePasswordNeededEventArgs";
import { WorksheetProtectedRange } from "igniteui-angular-excel";
/**
 * Event arguments for the
 * editRangePasswordNeeded event.
*/
export declare class IgxSpreadsheetEditRangePasswordNeededEventArgs extends IgxCancelEventArgs {
    /**
                                 * @hidden
                                 */
    get i(): SpreadsheetEditRangePasswordNeededEventArgs_internal;
    constructor();
    /**
     * Returns the collection of protected ranges that should be unlocked.
     * This collection contains the protected ranges that overlap with the
     * locked cells that need to be unlocked. There may be multiple ranges that overlap the locked
     * cells so it may not be that every range needs to be unlocked.
    */
    get ranges(): WorksheetProtectedRange[];
    static ngAcceptInputType_ranges: WorksheetProtectedRange[] | string;
    /**
     * Unlocks the associated range(s) without validating the password.
    
    */
    unprotect(): void;
}
